// [=====================================================================]

//    Name:  ProtocolManager.h				Last Modified:  
//    Author:							First Working:  
//  
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#if !defined(AFX_PROTOCOLMANAGER1_H__349B84B0_5311_4CB7_BBC3_01AE53F23064__INCLUDED_)
#define AFX_PROTOCOLMANAGER1_H__349B84B0_5311_4CB7_BBC3_01AE53F23064__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ProtocolManager.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CProtocolManager window

class CProtocolManager : public CWnd
{
// Construction
public:
	CProtocolManager();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProtocolManager)
	//}}AFX_VIRTUAL

// Implementation
private:
	void Hex_Ascii(byte *pBHex,byte *pBAscii, int *ipLen);
	void KSNVisa (int iEncryption,byte* bpRawKey,byte* bpSProtocol,int* ipLength);
	void KSNSymbol(int iEncryption,byte* bpRawKey,byte* bpSProtocol,int* ipLength);
	int validateStatus_Visa(byte *bpResponse);
	int validateInject_Visa(byte *bpResponse,byte* bpCKV);
	byte getsCRC(byte* bpData,byte bKey,int iLen);
	void StatusVisa(byte* bpSProtocol,int *ipLength);
	void StatusSymbol(byte* bpSProtocol,int *ipLength);
	void InjectSymbol( int iEncryption,byte* bpRawKey,byte* bpData,int* ipLength);
	int getEncodedLength( int EncodeLength);
	void InjectVisa(int iEncryption,byte* bpRawKey,byte* bpData,int* ipLength);
	int validateStatus_Symbol(byte *bpResponse);
	int validateInject_Symbol( byte* bpResponse,byte* bpCKV);

	// Generated message map functions
protected:
	//{{AFX_MSG(CProtocolManager)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
public:
	virtual ~CProtocolManager();
	void getKSNData(int iProtocol, int iEncryption, byte *bpRawKey,byte *bpSProtocol, int *ipLength);
	int validateStatus(int iProtocol,byte *bpResponse);
	int validateInject(int iProtocol,byte *bpResponse,byte* bpCKV);
	void getInjectData(int iProtocol,int iEncryption,byte* bpRawKey,byte *bpData,int* ipLength);
	void getStatusData(byte* bpData,int iProtocol,  int *ipLength);

	//int validateStatus(byte *bpResponse);
	//int validateInject( byte* bpResponse,byte* bpCKV);
	//byte* getInjectData(int iProtocol,int iEncryption,byte* bpRawKey,int* ipLength);
	//byte* getStatusData(int iProtocol,  int *ipLength);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROTOCOLMANAGER1_H__349B84B0_5311_4CB7_BBC3_01AE53F23064__INCLUDED_)
