// [=====================================================================]

//    Class Name:  CPortSetter      Last Modified:  
//    Author:						First Working:  
		
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#include "stdafx.h"
#include "KeyInjectModule.h"
#include "PortSetter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPortSetter dialog


CPortSetter::CPortSetter(CWnd* pParent /*=NULL*/)
	: CDialog(CPortSetter::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortSetter)
	m_strPortNo = _T("COM1");
	m_strBaurdRate = _T("9600");
	m_strParity = _T("EVENPARITY");
	m_strDataBits = _T("7");
	m_strStopBits = _T("1");
	//}}AFX_DATA_INIT
}


void CPortSetter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortSetter)
	DDX_CBString(pDX, IDC_PORT_NO, m_strPortNo);
	DDX_CBString(pDX, IDC_BAURD_RATE, m_strBaurdRate);
	DDX_CBString(pDX, IDC_PARITY, m_strParity);
	DDX_CBString(pDX, IDC_DATA_BITS, m_strDataBits);
	DDX_CBString(pDX, IDC_STOP_BITS, m_strStopBits);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortSetter, CDialog)
	//{{AFX_MSG_MAP(CPortSetter)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortSetter message handlers


void CPortSetter::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::CalcWindowRect(lpClientRect, nAdjustType);
}



BOOL CPortSetter::PreTranslateMessage(MSG* pMsg) 
{
	
	
	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CPortSetter::PreCreateWindow(CREATESTRUCT& cs) 
{
	
	SetDlgItemText(IDC_PORT_NO,"COM1");
	SetDlgItemText(IDC_BAURD_RATE,"9600");
	SetDlgItemText(IDC_PARITY,"EVENPARITY");
	SetDlgItemText(IDC_DATA_BITS,"7");
	SetDlgItemText(IDC_STOP_BITS,"1");

	return CDialog::PreCreateWindow(cs);
}

