// idt_usb_hid.h

#ifndef IDT_USB_HID
#define IDT_USB_HID

//#include "stdafx.h"
#include <setupapi.h>
extern "C"
{
#include "AID\hidsdi.h"
}

class CIdtUsbHid
{
	UINT  m_uiVID, m_uiPID;
	OVERLAPPED m_overlapped;
	HANDLE m_ReadEvent;
	HIDP_CAPS m_caps;
	char m_devPathName[1024];
	HANDLE m_hidDevice;

public:
	CIdtUsbHid();

	unsigned int LookDevice(UINT auiVid, UINT auiPid);

	unsigned int Write(unsigned char* aucmpData, unsigned int auiDataLen) ;

	unsigned int GetReport(unsigned char* aucmpData, unsigned int auiWaitInMs);
	unsigned int GetResponse(unsigned char* aucmpData, unsigned int auiRespLen, unsigned int auiWaitInMs);
	unsigned int SendCommand(UINT auiVid, UINT auiPid, unsigned char* aucmpSource, unsigned int auiSourceLen, unsigned char* aucmpResp, unsigned int auiRespLen, unsigned int auiWaitInMs);
};

#endif